#include	"test.h"

void
handler() {
#if	0
	printf(">>>> sigcont handler start\n");
	printf(">>>> sigcont handler end\n");
#endif
}

main(
int	argc,
char	*argv[]
) {
	int			semid = strtol(argv[1], NULL, 0);
	struct sched_param	p;
	struct sigaction	act;
	sigset_t		set;
	struct sembuf		sops[1];
	int			ret;

#ifdef	CGE
	p.sched_priority = 48;
	if (sched_setscheduler(0, SCHED_FIFO, &p) < 0) errprint(sched_setscheduler);
#endif

#if	0
	sigaction(SIGCONT, NULL, &act);
	act.sa_handler = handler;
	act.sa_flags   = 0;
	sigaction(SIGCONT, &act, NULL);
	sigemptyset(&set);
	sigaddset(&set, SIGCONT);
	sigprocmask(SIG_UNBLOCK, &set, NULL);
#endif

	sops[0].sem_num = 0;
	sops[0].sem_op  = 0;
	sops[0].sem_flg = 0;
	if (semop(semid, sops, 1) < 0) errprint(semop);

	for (;;) {
#if	0
		sigemptyset(&set);
		sigaddset(&set, SIGCONT);
		sigprocmask(SIG_BLOCK, &set, NULL);
#endif

		printf(">>> child process start\n");

		sops[0].sem_op = -1;
		do
			if ((ret = semop(semid, sops, 1)) < 0) errprint(semop);
		while (ret < 0 && errno == EINTR);

		sops[0].sem_op = 1;
		if (semop(semid, sops, 1) < 0) errprint(semop);

		printf("<<< child process end\n");

#if	0
		sigprocmask(SIG_UNBLOCK, &set, NULL);
#endif
	}

	exit(EXIT_SUCCESS);
}
